#!/usr/bin/php
<?php

include_once "smsacknowledge.inc.php";
include_once "/opt/monitor/op5/smsreceive/smsreceiver/utils.php";
include_once 'op5/livestatus.php';

if ($argc < 2)
{
	printLog("Wrong number of arguments, aborting");
	exit(1);
}

printLog("Ack sms '$argv[1]'");
$incommingmessage = processSmsMessage($argv[1]);

smsack($incommingmessage);

deletefile($argv[1]);

function get_contact_by_pager($nr)
{
	$ls = new Op5Livestatus(array('path' => '/opt/monitor/var/rw/live'));
	list($cols, $resp, $count) = $ls->query("contacts", array("Filter: pager = $nr"), array("contact_name"), array('auth' => false));
	if (is_array($resp) && count($resp) >= 1 && isset($resp[0][0])) {
		printLog("  Found contact: " . $resp[0][0] . "\n");
		return $resp[0][0];
	}

	return false;
}

function get_host_by_msg($msg)
{
	$ls = new Op5Livestatus(array('path' => '/opt/monitor/var/rw/live'));

	$on = strstr($msg, " on ");
	if (!$on)
		return False;

	printLog(" ON: $on\n");
	$submsg = substr($on, 4);
	printLog(" submsg: $submsg\n");

	$hname = preg_replace('/([^ ]*) is [A-Z].*/', '$1', $submsg);
	printLog(" hname: $hname\n");

	list($cols, $resp, $count) = $ls->query("hosts", array("Filter: host_name = $hname"), array('alias'), array('auth' => false));
	if (is_array($resp) && count($resp === 1) && isset($resp[0][0])) {
		printLog(" hname found. Things are looking good ;)\n");
		return $hname;
	}

	return '';
}

function smsack($smsmessage)
{
	GLOBAL $sticky, $notify, $persistent, $hostAckString, $serviceAckString;
	GLOBAL $smsDelimiter, $smsDynamicDelimiter, $commandfile;

	$smsArr = explode($smsDelimiter, $smsmessage['content']);
	$commandString = "";

	$author = get_contact_by_pager($smsmessage['from']);
	if ($author === False) {
		printLog("No contact found with pager number $smsmessage[from]");
	} else {
		printLog("Pager number " . $smsmessage['from'] . " belongs to contact $author");
	}
	# First, look for manually witten  acknowledge messages
	if (strcasecmp($smsArr[0], $hostAckString) === 0) {
		printLog("Host ack");
		$commandString = "ACKNOWLEDGE_HOST_PROBLEM;" . $smsArr[1] . ";";
		$commandString .=  $sticky . ";" . $notify . ";" . $persistent . ";";
		$commandString .=  $author . ";" . $smsArr[2];
	} else if (strcasecmp($smsArr[0], $serviceAckString) === 0) {
		printLog("Service ack");
		$commandString = "ACKNOWLEDGE_SVC_PROBLEM;" . $smsArr[1] . ";";
		$commandString .=  $smsArr[2] . ";" . $sticky . ";" . $notify . ";" . $persistent;
		$commandString .=  ";" . $author . ";" . $smsArr[3];
	} else {
		# Fall back, try to match on sms-reply
		$tmpStr = strtok($smsmessage['content'], $smsDynamicDelimiter);
		$tmpArr = explode(" ", $tmpStr);
		$c = count($tmpArr);
		$index = 0;
		$serviceDescr = "";
		# Try to match on service ack
		$hostName = get_host_by_msg($tmpStr);
		if ($hostName != '') {
			printLog("Fallback, service ack");
			$tmpArr2 = explode(" on " . $hostName . " ", $tmpStr);
			$serviceDescr = $tmpArr2[0];
			$commandString = "ACKNOWLEDGE_SVC_PROBLEM;" . $hostName . ";";
			$commandString .=  $serviceDescr . ";" . $sticky . ";" . $notify . ";" . $persistent . ";";
			$commandString .=  $author . ";SMS acknowledgement";
		} else {
			# Final fallback, interpret message as host ack
			printLog("Fallback, host ack");
			$commandString = "ACKNOWLEDGE_HOST_PROBLEM;" . $tmpArr[0] . ";" ;
			$commandString .=  $sticky . ";" . $notify . ";" . $persistent . ";" . $author;
			$commandString .=   ";SMS acknowledgement";
		}

	}
	printLog("About to write: '$commandString' to commandfile");

	$fHandle = fopen($commandfile, "a");
	if (!$fHandle) {
		printLog("Failed to open file '$commandfile' for writing, Aborting.");
		return;
	}
	$ret = fwrite($fHandle, "[". time() . "] " . $commandString . "\n");
	if (!$ret) {
		printLog("Failed to write file '$commandfile'");
	}
	fclose($fHandle);
}
